accounts/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static
from accounts.views import *

app_name = 'accounts'

urlpatterns = [
    path('register/', register, name='register'),
    path('login/', login, name='login'),
    path('forgot_password/', forgot_password, name='forgot_password'),
    path('activate_account/', activate_account, name='activate_account'),
    path('reset_password/', reset_password, name='reset_password'),
    path('user_profile/', user_profile, name='user_profile'),
    path('update_personal_data/', update_personal_data, name='update_personal_data'),
    path('update_address_data/', update_address_data, name='update_address_data'),
    path('update_bank_data/', update_bank_data, name='update_bank_data'),
    path('change_password/', change_password, name='change_password'),
    path('send_promotion/', home_mail_sending, name='send_mail'),
    path('logout/', logout, name='logout')
]

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

base/urls.py
from django.urls import path
from django.conf import settings
from django.conf.urls.static import static
from base.views import *

app_name = 'base'

urlpatterns = [
    path('', home, name='home'),
    path('faq/', faq, name='faq'),
    path('contacts/', contact, name='contacts'),
    path('about-us/', about, name='about'),
    path('investments/', investments, name='investments'),
    path('past_projects/', past_projects, name='past_projects'),
    path('investment/<str:name>', investment, name='investment'),
    path('investment_form/<str:invest>', investment_form, name='investment_form'),
    path('choose_payment/<int:invest>', choose_payment, name='choose_payment'),
    path('my_transactions/', my_transactions, name='my_transactions'),
    path('my_investments/', my_investments, name='my_investments'),
    path('delete_investment/<int:id>', delete_investment, name='delete_investment'),
    path('user_question/', question_through_email, name='question_through_email'),
]
urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

solomartel/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static


urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('base.urls'), name='base'),
    path('accounts/', include('accounts.urls'), name='accounts'),
    path('payment/', include('payment.urls'), name='payments')
]

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

accounts/models.py
from django.db import models
from django.contrib.auth import get_user_model
from django_countries.fields import CountryField

User = get_user_model()
ENTITY_TYPES = (
    ('Company', 'Company'),
    ('Trust', 'Trust'),
    ('Institutional account', 'Institutional account'),
    ('Other entity', 'Other entity')
)

ACCOUNT_TYPES = (
    ('Checking', 'Checking'),
    ('Saving', 'Saving'),
    ('Retirement', 'Retirement')
)


class Client(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE)
    legal_name = models.CharField(max_length=255)
    address = models.CharField(max_length=255)
    region = models.CharField(max_length=255)
    zip = models.IntegerField()
    country = models.CharField(max_length=255)
    city = models.CharField(max_length=255)
    phone_number = models.CharField(max_length=16)
    bank_name = models.CharField(max_length=255)
    swift_code = models.CharField(max_length=255)
    ABA_number = models.IntegerField(default=0)  # Only when country is USA
    SSN = models.IntegerField(default=0)  # Only when country is USA
    notes = models.TextField(null=True)
    token = models.CharField(max_length=20)

    # investments, association table
    # payment_method, association table

    def __str__(self):
        return self.legal_name


class Private(Client):
    # Account, association table

    def __str__(self):
        return self.legal_name


class Entity(Client):
    type = models.CharField(max_length=255, choices=ENTITY_TYPES)

    def __str__(self):
        return self.legal_name


class Account(models.Model):
    type = models.CharField(max_length=255, choices=ACCOUNT_TYPES)
    account_number = models.IntegerField(unique=True)  # Tell if it has some validation for this field.
    funds = models.DecimalField(max_digits=10, decimal_places=2, verbose_name='Funds ($)', default=0)
    owner = models.ForeignKey(Client, on_delete=models.CASCADE, related_name='my_accounts')

    def __str__(self):
        return str(self.account_number)

accounts/views.py
from django.conf import settings
from django.contrib import messages
from django.core.mail import send_mail
from django.http import HttpResponseRedirect
from django.template.loader import render_to_string
from django.contrib.auth.decorators import login_required
from django.contrib.sites.shortcuts import get_current_site
from accounts.models import User, Private, Entity, Account, Client
from django.shortcuts import render, reverse, redirect, HttpResponse
from django.contrib.auth import authenticate, login as login_user, logout as logout_user

import sys
import json
import secrets


# Create your views here.
def register(request):
    """
    Create an function for registering an user in database
    :param request:
    :return:
    """

    context = {}
    try:
        if request.method == 'POST':
            username = request.POST.get('user_name')
            email = request.POST.get('email')
            password = request.POST.get('password')
            menu1 = request.POST.get('menu1')
            ssn = int(request.POST.get('ssn'))

            if User.objects.filter(username=username).exists():
                context['msg'] = 'Sorry, this username already exist'
                return render(request, 'accounts/base/register.html', context)

            if User.objects.filter(email=email).exists():
                context['msg'] = 'Sorry, this email already exist'
                return render(request, 'accounts/base/register.html', context)

            user_obj = User.objects.create(username=username, email=email)
            user_obj.set_password(password)
            user_obj.is_active = False
            user_obj.save()

            if menu1 == 'Private_Investor':
                legal_name = request.POST.get('legal_name')
                address = request.POST.get('address')
                region = request.POST.get('region')
                zipcode = int(request.POST.get('zipcode'))
                country = request.POST.get('e_country')
                city = request.POST.get('city')

                user = Private.objects.create(
                    user=user_obj,
                    legal_name=legal_name,
                    address=address,
                    region=region,
                    zip=zipcode,
                    country=country,
                    city=city
                )

            elif menu1 == 'Investing_via_entity':
                legal_name = request.POST.get('legal_investing')
                address = request.POST.get('entity_adress')
                region = request.POST.get('entity_region')
                zipcode = int(request.POST.get('entity_zip_Code'))
                countary = request.POST.get('entity_country')
                city = request.POST.get('entity_city')
                entity_type = request.POST.get('entity_type')

                user = Entity.objects.create(
                    user=user_obj,
                    legal_name=legal_name,
                    address=address,
                    region=region,
                    zip=zipcode,
                    country=countary,
                    city=city,
                    type=entity_type
                )

            account_type = request.POST.get('account_type')
            account_number = int(request.POST.get('account_number'))

            swiftcode = request.POST.get('swiftcode')
            financial_account = request.POST.get('financial_account')
            notes = request.POST.get('notes')

            if Account.objects.filter(account_number=account_number).exists():
                context['msg'] = 'Account number must be unique, this account number already exists'
                return render(request, 'accounts/base/register.html', context)

            Account.objects.create(
                type=account_type,
                account_number=account_number,
                owner=user
            )

            user.swift_code = swiftcode
            user.bank_name = financial_account
            user.SSN = ssn
            user.notes = notes

            token = secrets.token_hex(20)
            user.token = token
            user.save()

            # Send activation email
            site_url = get_current_site(request)
            subject = 'Activate Your Account'
            message = ""
            email_from = settings.EMAIL_HOST_USER
            recipient_list = [email]
            html_message = render_to_string('accounts/email/verified.html',
                                            {'username': user_obj.username, 'email': email,
                                             'token': token, 'site_url': site_url})
            send_mail(subject, message, f'Solomartel Holdings<{email_from}>', recipient_list, html_message=html_message,
                      fail_silently=False)

            messages.success(request,
                             'Thank you for your registration! Your account has been successfully created. An email has been sent to you with detailed instructions on how to activate it')
            return redirect(reverse('accounts:login'))

        return render(request, 'accounts/base/register.html')
    except:
        import traceback
        traceback.print_exc()
        messages.error(request, 'Something went wrong, please try again later')
        return render(request, 'accounts/base/register.html', context)


def activate_account(request):
    try:
        token = request.GET.get('token')
        email = request.GET.get('email')
        try:
            user = User.objects.get(email=email)

            client = Client.objects.get(user=user)
            # print("user_info", user_info)
            # user_saved_token = user_info[0].token
            # print(user_saved_token)
            if client.token == token:
                client.user.is_active = True
                client.user.save()
                messages.success(request, 'You have successfully confirmed your account, Please Login Here')

                return redirect(reverse('accounts:login'))
            else:
                messages.error(request, 'Invalid Token, please try again')
                return redirect(reverse('accounts:login'))
        except User.DoesNotExist:
            messages.error(request, "Invalid email address, please try again")
            return redirect(reverse('accounts:login'))
        except Client.DoesNotExist:
            messages.error(request, "You are not client in our website, please try again")
            return redirect(reverse('accounts:login'))
        except Exception as e:
            messages.error(request, str(e))
            return redirect(reverse('accounts:login'))
    except:
        messages.error(request, "Something went wrong, please try again")
        return redirect(reverse('accounts:login'))


def login(request):
    """
    Make a function for login an user account
    :param
    request:
    :return:
    """
    context = {}
    if not request.user.is_authenticated:
        try:
            if request.method == 'POST':
                username = request.POST['username']
                password = request.POST['password']
                user = authenticate(username=username, password=password)
                if user is not None:
                    if user.is_active:
                        login_user(request, user)
                        return redirect(reverse('base:home'))
                    else:
                        context['msg'] = 'Sorry, you have not confirmed your account, check your mail'
                        return render(request, 'accounts/base/login.html', context)
                else:
                    context['msg'] = 'Incorrect username or password/Check your mail to activate your account'
                    return render(request, 'accounts/base/login.html', context)
            return render(request, 'accounts/base/login.html', context)
        except:
            import traceback
            traceback.print_exc()
            context['msg'] = 'Something went wrong, Please try again later'
            return render(request, 'accounts/base/login.html', context)
    else:
        return redirect(reverse('base:home'))


def logout(request):
    logout_user(request)
    return redirect(reverse('base:home'))


def forgot_password(request):
    """
    call a function when user will lost his password
    :param request:
    :return:
    """
    context = {}

    try:
        if request.method == 'POST':
            site_url = get_current_site(request)
            site_url = str(site_url)
            email = request.POST.get('email')

            try:
                user = User.objects.get(email=email)
                subject = "Forget password"
                email_from = settings.EMAIL_HOST_USER
                recipient_list = [email]
                message = ''
                html_message = render_to_string('accounts/email/forget_email.html',
                                                {'user_info': user, 'email': email
                                                    , 'site_url': site_url})
                send_mail(subject, message, f'Solomartel Holdings<{email_from}>', recipient_list,
                          html_message=html_message, fail_silently=False)
                context['msg'] = 'Email sends successfully'
                context['success'] = True

            except User.DoesNotExist:
                context[
                    'msg'] = 'No user account registered with provided information. Please check your details and try again'
        return render(request, 'accounts/base/forgot.html', context)

    except:
        import traceback
        traceback.print_exc()
        context['msg'] = 'Something went wrong, please try again later'
        return render(request, 'accounts/base/forgot.html', context)


def reset_password(request):
    print('something')
    context = {}
    try:
        email = request.GET.get('q')
        user = User.objects.get(email=email)

accounts/templates/accounts/base/base.html
{% load static %}
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    {% block title %}
    <title></title>
    {% endblock title %}

    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=0">
    <link href="https://fonts.googleapis.com/css?family=Roboto:300,400,500,700,900" rel="stylesheet">

    <link href="{% static 'vendor/bootstrap/css/bootstrap.min.css' %}" rel="stylesheet">

    <!-- Bootstrap select CSS-->
    <link rel="stylesheet"
          href="https://cdn.jsdelivr.net/npm/bootstrap-select@1.13.12/dist/css/bootstrap-select.min.css" defer async>

    <!-- Custom styles for this template-->
    <link href="{% static 'css/sb-admin.css' %}" rel="stylesheet">
    <link href="{% static 'css/custom.css' %}" rel="stylesheet">
    <link href="{% static 'css/gradient.css' %}" rel="stylesheet">
    <link href="{% static '/css/style.css' %}" rel="stylesheet">

    <!-- Bootstrap core JavaScript-->
    <script src="{% static 'vendor/jquery/jquery.min.js' %}"></script>

    {% block styles_page %}
    {% endblock styles_page %}
</head>

<body style="background-color: {% block body_color %}{% endblock body_color %}">
<div class="container">

    <div class="col-sm-10 offset-sm-1">

        <div class="widget">
            <br>
            <br>
            <div class="widget-header">
                <div class="row">

                    <div class="col-sm-4">
                        <a class="rd-navbar-brand" href="{% url 'base:home' %}"><img
                                src="{% static 'images/logo.png' %}" alt="" width="181" height="84"
                                srcset="{% static 'images/logo.png' %} x2"/></a>
                        <br>
                        <br>
                        <br>
                    </div>
                    <!-- <div class="col-cm-6 ml-auto">
                      <a class="btn btn-primary" style="background-color:#2a72d2" href="/eol_app/excel_add_user/">Upload File </a>
                    </div> -->
                </div>
            </div>
            {% block content %}
            {% endblock content %}
        </div>
    </div>
</div>
{% block scripts_page %}
{% endblock scripts_page %}
</body>
</html>

accounts/templates/accounts/base/forgot.html
{% extends 'accounts/base/base.html' %}
{% load static %}
{% block title %}
<title>Forgot Password | Solomartel</title>
{% endblock %}

{% block styles_page %}
<style>
  label::after {
    content: "*";
    color: red;
  }
 .checkbox:after{
  content: none;
  }
.g_st.without-after-element:after {
    content: none;

  }
  .form-control.has-error {
    border: 1px solid #FB404B !important;
    color: #FB404B !important;
}

.form-control.has-success {
    border: 1px solid #28a745 !important;
    color: #28a745 !important;

}
.error-msg {
    color: red;
    font-size: 13px;
    margin: 3px;
}

</style>
{% endblock styles_page %}

{% block content %}
            <div class="widget-content ">
                {% if msg %}
                <div class="alert {% if success %} alert-success {% else %} alert-danger {% endif %}" id="msg">{{msg}}</div>
                {% endif %}

                <form method="POST" action="{% url 'accounts:forgot_password' %}" id="forgotSubmit">
                    {% csrf_token %}

                    <div id="form_div">
                        <div class="row">
                            <div class="col-sm-12">
                                <div class="form-group">
                                    <label class="control-label col-sm-12" for="uname">Email Address</label>
                                    <div class="col-sm-12">
                                        <input type="text" class="form-control" minlength="3"
                                               maxlength="60" id="user_name_login"
                                               placeholder="Enter Email Address" name="email"
                                               onkeyup="Email_check_login()">
                                        <span class="error-msg"
                                              id="email_label_edit_login"></span>
                                    </div>
                                </div>
                            </div>

                        </div>


                        <div class="row mt-5">
                            <div class="col-sm-5 align-self-start">
                            </div>
                            <button style="background-color: #353578;border-color:#2a72d2" type="submit"
                                    class="btn btn-success">Reset Password
                            </button>

                        </div>
                    </div>
                </form>
                <a href="{% url 'accounts:register' %}">Back to login</a>
            </div>
{% endblock content%}

{% block scripts_page %}
<script src="{% static 'js/forgot.js' %}"></script>
{% endblock scripts_page %}

accounts/templates/accounts/base/login.html
{% extends 'accounts/base/base.html' %}
{% load static %}
{% block title %}
<title>Login | Solomartel</title>
{% endblock %}

{% block body_color %}
#353578 !important;
{% endblock body_color %}

{% block styles_page %}
<style>
.widget
{
    width: 70%;
    margin: auto;
}

  label::after {
    content: "*";
    color: red;
  }
 .checkbox:after{
  content: none;
  }
.g_st.without-after-element:after {
    content: none;

  }
  .form-control.has-error {
    border: 1px solid #FB404B !important;
    color: #FB404B !important;
}

.form-control.has-success {
    border: 1px solid #28a745 !important;
    color: #28a745 !important;

}
.error-msg {
    color: red;
    font-size: 13px;
    margin: 3px;
}


</style>
{% endblock styles_page %}

{% block content %}
<div class="widget-content ">
    {% if messages %}
    <ul class="messages">
        {% for message in messages %}
        {% if 'success' in message.tags %}
        <li>
            <div class="alert alert-success">
                {{ message }}
            </div>
        </li>
        {% endif %}
        {% endfor %}
    </ul>
    {% endif %}
    {% if messages %}
    <ul class="msg_error_class">
        {% for message in messages %}
        {% if 'error' in message.tags %}
        <li>
            <div class="alert alert-danger">
                {{ message }}
            </div>
        </li>
        {% endif %}
        {% endfor %}
    </ul>
    {% endif %}
    {% if msg %}
    <div class="alert alert-danger" id="msg">{{msg}}</div>
    {% endif %}
    <form method="POST" action="{% url 'accounts:login' %}" id="login_submit">
        {% csrf_token %}

        <div id="form_div">
            <div class="row">
                <div class="col-sm-12">
                    <div class="form-group">
                        <label class="control-label col-sm-12" for="user_name_login">Username or Email Address</label>
                        <div class="col-sm-12">
                            <input type="text" class="form-control" minlength="3"
                                   maxlength="60" id="user_name_login"
                                   placeholder="Username or Email Address" name="username"
                                   onkeyup="Email_check_login()">
                            <span class="error-msg"
                                  id="email_label_edit_login"></span>
                        </div>
                    </div>
                </div>

            </div>
            <div class="form-group">
                <label class="control-label col-sm-12" for="password">Password</label>
                <div class="col-sm-12">
                    <input type="password" class="form-control" id="password" placeholder="Password"
                           name="password" onkeyup="Password_login()">
                    <span class="error-msg" id="password_label"></span>
                </div>
            </div>


            <div class="row mt-5 justify-content-center">
                <button style="background-color: #353578;border-color:#353578;" type="submit"
                        class="col-md-10 btn btn-success">Login
                </button>
            </div>
        </div>
        <br>
        <a href="{% url 'accounts:register' %}">Register</a> |
        <a href="{% url 'accounts:forgot_password' %}">Lost your password?</a>
    </form>
</div>
{% endblock content %}
{% block scripts_page %}
<script src="{% static 'js/login.js' %}"></script>
{% endblock scripts_page %}

accounts/templates/accounts/base/reset_password.html
{% extends 'accounts/base/base.html' %}
{% load static %}


{% block title %}
<title> Reset Password | Solomartel </title>
{% endblock title %}

{% block styles_page %}
<style>
  label::after {
    content: "*";
    color: red;
  }
 .checkbox:after{
  content: none;
  }
.g_st.without-after-element:after {
    content: none;

  }
  .form-control.has-error {
    border: 1px solid #FB404B !important;
    color: #FB404B !important;
}

.form-control.has-success {
    border: 1px solid #28a745 !important;
    color: #28a745 !important;

}
.error-msg {
    color: red;
    font-size: 13px;
    margin: 3px;
}




</style>
{% endblock styles_page %}

{% block content %}
<div class="widget-content ">
    {% if msg %}
    <div class="alert alert-danger" id="msg">{{msg}}</div>
    {% endif %}
    {% if success %}
    <form method="POST" action="{% url 'accounts:reset_password' %}?q={{ email }}" id="forgotSubmit">
        {% csrf_token %}
        <div id="form_div">
            <div class="row">
                <div class="col-sm-12">
                    <div class="form-group">
                        <label class="control-label col-sm-12" for="psw_customer">New Password</label>
                        <div class="col-sm-12">
                            <input type="password" class="form-control" minlength="3"
                                   maxlength="30" id="psw_customer"
                                   placeholder="New Password" name="password" onkeyup="Password()">
                            <span class="error-msg"
                                  id="password_label"></span>
                        </div>
                    </div>
                </div>
                <div class="col-sm-12">
                    <div class="form-group">
                        <label class="control-label col-sm-12" for="otp_field"> Otp</label>
                        <div class="col-sm-12">
                            <input type="number" id="otp_field" class="form-control" minlength="3" maxlength="5"
                                   placeholder="Otp" name="otp" onkeyup="Otp_check()">
                            <span class="error-msg"
                                  id="otp_label_text"></span>
                        </div>
                    </div>
                </div>

            </div>


            <div class="row mt-5">
                <div class="col-sm-5 align-self-start">
                </div>
                <button style="background-color: #353578;border-color:#2a72d2" type="submit"
                        class="btn btn-success">Update Password
                </button>

            </div>
        </div>
    </form>
    {% endif %}
    <a href="{% url 'accounts:login' %}">Back to login</a>
</div>
{% endblock content %}

{% block scripts_page %}
<script src="{% static 'js/reset_psw.js' %}"></script>
{% endblock scripts_page %}